summaryrefslogtreecommitdiff
path: root/net-dialup/ppp
diff options
context:
space:
mode:
authorGluzskiy Alexandr <sss123next@list.ru>2010-08-30 07:52:44 +0300
committerGluzskiy Alexandr <sss123next@list.ru>2010-08-30 07:52:44 +0300
commit07be95a20d64451cd6b28ac1b79bfff05ab3700f (patch)
tree80ca4c206572e31eb234b9dbf19888b00db030b2 /net-dialup/ppp
parent59dc52cd088fbfd2252277abd44d7318a5c4d4d7 (diff)
patched for pause between reconnect ppp (for my needs, maybe useful for someone else)
Diffstat (limited to 'net-dialup/ppp')
-rw-r--r--net-dialup/ppp/files/README.mpls15
-rw-r--r--net-dialup/ppp/files/modules.ppp10
-rw-r--r--net-dialup/ppp/files/ppp_pause_between_reconnect.patch73
-rw-r--r--net-dialup/ppp/ppp-2.4.5-r1.ebuild279
4 files changed, 377 insertions, 0 deletions
diff --git a/net-dialup/ppp/files/README.mpls b/net-dialup/ppp/files/README.mpls
new file mode 100644
index 0000000..1ae7ae4
--- /dev/null
+++ b/net-dialup/ppp/files/README.mpls
@@ -0,0 +1,15 @@
+MPLS consists of 3 components:
+1. MPLS forwarding
+2. MPLS signalling
+3. Mapping layer 3 traffic onto MPLS LSPs
+
+The document mpls-forwarding basics explains item 1.
+
+Examples of MPLS signalling protocols are: RSVP-TE LDP and CR-LDP.
+The package ldp-portable is an implementation of LDP and contains more
+information about LDP based MPLS signalling.
+
+Mapping of layer 3 traffic to MPLS LSPs is accomplised in a couple of
+different ways.
+-Per FEC where FEC is an entry in the routing table
+-Virtual interface that represents an LSP
diff --git a/net-dialup/ppp/files/modules.ppp b/net-dialup/ppp/files/modules.ppp
new file mode 100644
index 0000000..e936041
--- /dev/null
+++ b/net-dialup/ppp/files/modules.ppp
@@ -0,0 +1,10 @@
+alias char-major-108 ppp_generic
+alias /dev/ppp ppp_generic
+alias tty-ldisc-3 ppp_async
+alias tty-ldisc-13 n_hdlc
+alias tty-ldisc-14 ppp_synctty
+alias ppp-compress-18 ppp_mppe
+alias ppp-compress-21 bsd_comp
+alias ppp-compress-24 ppp_deflate
+alias ppp-compress-26 ppp_deflate
+alias net-pf-24 pppoe
diff --git a/net-dialup/ppp/files/ppp_pause_between_reconnect.patch b/net-dialup/ppp/files/ppp_pause_between_reconnect.patch
new file mode 100644
index 0000000..3507593
--- /dev/null
+++ b/net-dialup/ppp/files/ppp_pause_between_reconnect.patch
@@ -0,0 +1,73 @@
+diff -Naur ppp-2.4.5/pppd/main.c ppp-2.4.5_patched/pppd/main.c
+--- ppp-2.4.5/pppd/main.c 2010-08-30 07:36:35.000000000 +0300
++++ ppp-2.4.5_patched/pppd/main.c 2010-08-30 07:41:10.844666729 +0300
+@@ -565,6 +565,8 @@
+
+ if (!persist || asked_to_quit || (maxfail > 0 && unsuccess >= maxfail))
+ break;
++ else
++ sleep(pause_between_reconnect);
+
+ if (demand)
+ demand_discard();
+@@ -581,6 +583,8 @@
+ } while (phase == PHASE_HOLDOFF);
+ if (!persist)
+ break;
++ else
++ sleep(pause_between_reconnect);
+ }
+
+ wait_children();
+diff -Naur ppp-2.4.5/pppd/options.c ppp-2.4.5_patched/pppd/options.c
+--- ppp-2.4.5/pppd/options.c 2010-08-30 07:36:35.000000000 +0300
++++ ppp-2.4.5_patched/pppd/options.c 2010-08-30 07:44:05.162666733 +0300
+@@ -101,6 +101,7 @@
+ char user[MAXNAMELEN]; /* Username for PAP */
+ char passwd[MAXSECRETLEN]; /* Password for PAP */
+ bool persist = 0; /* Reopen link after it goes down */
++int pause_between_reconnect = 5; /* set pause between reconnects to avoid log flood/high cpu usage */
+ bool killoldaddr = 0; /* If our IP is reassigned on
+ reconnect, kill active TCP
+ connections using the old IP. */
+@@ -229,6 +230,8 @@
+
+ { "persist", o_bool, &persist,
+ "Keep on reopening connection after close", OPT_PRIO | 1 },
++ { "pause_between_reconnects", o_int, &pause_between_reconnect,
++ "set pause between reconnects to avoid log flood/high cpu usage", OPT_PRIO },
+ { "nopersist", o_bool, &persist,
+ "Turn off persist option", OPT_PRIOSUB },
+
+diff -Naur ppp-2.4.5/pppd/pppd.h ppp-2.4.5_patched/pppd/pppd.h
+--- ppp-2.4.5/pppd/pppd.h 2010-08-30 07:36:35.000000000 +0300
++++ ppp-2.4.5_patched/pppd/pppd.h 2010-08-30 07:44:39.502666729 +0300
+@@ -294,6 +294,7 @@
+ extern char passwd[MAXSECRETLEN]; /* Password for PAP or CHAP */
+ extern bool auth_required; /* Peer is required to authenticate */
+ extern bool persist; /* Reopen link after it goes down */
++extern int pause_between_reconnect; /* set pause between reconnects to avoid log flood/high cpu usage */
+ extern bool uselogin; /* Use /etc/passwd for checking PAP */
+ extern bool session_mgmt; /* Do session management (login records) */
+ extern char our_name[MAXNAMELEN];/* Our name for authentication purposes */
+diff -Naur ppp-2.4.5/pppd/tty.c ppp-2.4.5_patched/pppd/tty.c
+--- ppp-2.4.5/pppd/tty.c 2009-11-17 00:26:07.000000000 +0200
++++ ppp-2.4.5_patched/pppd/tty.c 2010-08-30 07:42:39.874666731 +0300
+@@ -582,6 +582,8 @@
+ }
+ if (!persist || err != EINTR)
+ goto errret;
++ else
++ sleep(pause_between_reconnects);
+ }
+ ttyfd = real_ttyfd;
+ if ((fdflags = fcntl(ttyfd, F_GETFL)) == -1
+@@ -731,6 +733,8 @@
+ }
+ if (!persist || errno != EINTR || hungup || got_sigterm)
+ goto errret;
++ else
++ sleep(paus_between_reconnect);
+ }
+ close(i);
+ }
diff --git a/net-dialup/ppp/ppp-2.4.5-r1.ebuild b/net-dialup/ppp/ppp-2.4.5-r1.ebuild
new file mode 100644
index 0000000..cf6dc83
--- /dev/null
+++ b/net-dialup/ppp/ppp-2.4.5-r1.ebuild
@@ -0,0 +1,279 @@
+# Copyright 1999-2010 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# $Header: /var/cvsroot/gentoo-x86/net-dialup/ppp/ppp-2.4.5.ebuild,v 1.1 2010/08/08 10:24:22 mrness Exp $
+
+EAPI="2"
+
+inherit eutils toolchain-funcs linux-info pam
+
+DESCRIPTION="Point-to-Point Protocol (PPP)"
+HOMEPAGE="http://www.samba.org/ppp"
+SRC_URI="ftp://ftp.samba.org/pub/ppp/${P}.tar.gz
+ mirror://gentoo/${P}-gentoo-20100808.tar.gz
+ dhcp? ( http://www.netservers.co.uk/gpl/ppp-dhcpc.tgz )"
+
+LICENSE="BSD GPL-2"
+SLOT="0"
+KEYWORDS="~alpha ~amd64 ~arm ~hppa ~ia64 ~mips ~ppc ~ppc64 ~s390 ~sh ~sparc ~x86"
+IUSE="activefilter atm dhcp eap-tls gtk ipv6 pam radius"
+
+DEPEND="activefilter? ( virtual/libpcap )
+ atm? ( net-dialup/linux-atm )
+ pam? ( virtual/pam )
+ gtk? ( x11-libs/gtk+:2 )
+ eap-tls? ( net-misc/curl dev-libs/openssl )"
+RDEPEND="${DEPEND}"
+
+src_prepare() {
+ epatch "${WORKDIR}/patch/make-vars.patch"
+ epatch "${WORKDIR}/patch/mpls.patch"
+ epatch "${WORKDIR}/patch/killaddr-smarter.patch"
+ epatch "${WORKDIR}/patch/wait-children.patch"
+ epatch "${WORKDIR}/patch/defaultgateway.patch"
+ epatch "${WORKDIR}/patch/linkpidfile.patch"
+ epatch "${WORKDIR}/patch/qa-fixes.patch"
+ epatch "${WORKDIR}/patch/auth-fail.patch"
+ epatch "${WORKDIR}/patch/defaultmetric.patch"
+ epatch "${WORKDIR}/patch/dev-ppp.patch"
+ epatch "${WORKDIR}/patch/gtk2.patch"
+ epatch "${WORKDIR}/patch/passwordfd-read-early.patch"
+ epatch "${WORKDIR}/patch/pppd-usepeerwins.patch"
+ epatch "${WORKDIR}/patch/connect-errors.patch"
+ epatch "${FILESDIR}/ppp_pause_between_reconnect.patch"
+
+ use eap-tls && {
+ # see http://www.nikhef.nl/~janjust/ppp for more info
+ einfo "Enabling EAP-TLS support"
+ epatch "${WORKDIR}/patch/eaptls-mppe-0.98-gentoo.patch"
+ }
+
+ use atm && {
+ einfo "Enabling PPPoATM support"
+ sed -i "s/^#HAVE_LIBATM=yes/HAVE_LIBATM=yes/" pppd/plugins/pppoatm/Makefile.linux
+ }
+
+ use activefilter || {
+ einfo "Disabling active filter"
+ sed -i "s/^FILTER=y/#FILTER=y/" pppd/Makefile.linux
+ }
+
+ use pam && {
+ einfo "Enabling PAM"
+ sed -i "s/^#USE_PAM=y/USE_PAM=y/" pppd/Makefile.linux
+ }
+
+ use ipv6 && {
+ einfo "Enabling IPv6"
+ sed -i "s/#HAVE_INET6/HAVE_INET6/" pppd/Makefile.linux
+ }
+
+ einfo "Enabling CBCP"
+ sed -i "s/^#CBCP=y/CBCP=y/" pppd/Makefile.linux
+
+ use dhcp && {
+ # copy the ppp-dhcp plugin files
+ einfo "Adding ppp-dhcp plugin files..."
+ mv "${WORKDIR}/dhcp" "${S}/pppd/plugins" \
+ && sed -i -e 's/\(SUBDIRS := .*rp-pppoe.*\)$/\1 dhcp/' pppd/plugins/Makefile.linux \
+ || die "ppp-dhcp plugin addition failed"
+ epatch "${WORKDIR}/patch/dhcp-make-vars.patch"
+ epatch "${WORKDIR}/patch/dhcp-sys_error_to_strerror.patch"
+ }
+
+ # Set correct libdir
+ sed -i -e "s:/lib/pppd:/$(get_libdir)/pppd:" \
+ pppd/{pathnames.h,pppd.8}
+
+ if use radius; then
+ #set the right paths in radiusclient.conf
+ sed -i -e "s:/usr/local/etc:/etc:" \
+ -e "s:/usr/local/sbin:/usr/sbin:" pppd/plugins/radius/etc/radiusclient.conf
+ #set config dir to /etc/ppp/radius
+ sed -i -e "s:/etc/radiusclient:/etc/ppp/radius:g" \
+ pppd/plugins/radius/{*.8,*.c,*.h} \
+ pppd/plugins/radius/etc/*
+ else
+ einfo "Disabling radius"
+ sed -i -e '/+= radius/s:^:#:' pppd/plugins/Makefile.linux
+ fi
+}
+
+src_configure() {
+ export CC="$(tc-getCC)"
+ export AR="$(tc-getAR)"
+ econf || die "econf failed"
+}
+
+src_compile() {
+ emake COPTS="${CFLAGS} -D_GNU_SOURCE" || die "compile failed"
+
+ #build pppgetpass
+ cd contrib/pppgetpass
+ if use gtk; then
+ emake -f Makefile.linux || die "failed to build pppgetpass"
+ else
+ emake pppgetpass.vt || die "failed to build pppgetpass"
+ fi
+}
+
+src_install() {
+ local i
+ for i in chat pppd pppdump pppstats ; do
+ doman ${i}/${i}.8 || die "man page for ${i} not build"
+ dosbin ${i}/${i} || die "${i} not build"
+ done
+ fperms u+s-w /usr/sbin/pppd
+
+ # Install pppd header files
+ pushd pppd >/dev/null
+ emake INSTROOT="${D}" install-devel || die "emake install-devel failed"
+ popd >/dev/null
+
+ dosbin pppd/plugins/rp-pppoe/pppoe-discovery || die "pppoe-discovery not build"
+
+ dodir /etc/ppp/peers
+ insinto /etc/ppp
+ insopts -m0600
+ newins etc.ppp/pap-secrets pap-secrets.example || die "pap-secrets.example not found"
+ newins etc.ppp/chap-secrets chap-secrets.example || die "chap-secrets.example not found"
+
+ insopts -m0644
+ doins etc.ppp/options
+
+ exeinto /etc/ppp
+ for i in ip-up ip-down ; do
+ doexe "${WORKDIR}/scripts/${i}" || die "failed to install ${i} script"
+ insinto /etc/ppp/${i}.d
+ use ipv6 && dosym ${i} /etc/ppp/${i/ip/ipv6}
+ doins "${WORKDIR}/scripts/${i}.d"/* || die "failed to install ${i}.d scripts"
+ done
+
+ pamd_mimic_system ppp auth account session
+
+ local PLUGINS_DIR=/usr/$(get_libdir)/pppd/$(awk -F '"' '/VERSION/ {print $2}' pppd/patchlevel.h)
+ #closing " for syntax coloring
+ insinto "${PLUGINS_DIR}"
+ insopts -m0755
+ doins pppd/plugins/minconn.so || die "minconn.so not build"
+ doins pppd/plugins/passprompt.so || die "passprompt.so not build"
+ doins pppd/plugins/passwordfd.so || die "passwordfd.so not build"
+ doins pppd/plugins/winbind.so || die "winbind.so not build"
+ doins pppd/plugins/rp-pppoe/rp-pppoe.so || die "rp-pppoe.so not build"
+ doins pppd/plugins/pppol2tp/openl2tp.so || die "openl2tp.so not build"
+ doins pppd/plugins/pppol2tp/pppol2tp.so || die "pppol2tp.so not build"
+ if use atm; then
+ doins pppd/plugins/pppoatm/pppoatm.so || die "pppoatm.so not build"
+ fi
+ if use dhcp; then
+ doins pppd/plugins/dhcp/dhcpc.so || die "dhcpc.so not build"
+ fi
+ if use radius; then
+ doins pppd/plugins/radius/radius.so || die "radius.so not build"
+ doins pppd/plugins/radius/radattr.so || die "radattr.so not build"
+ doins pppd/plugins/radius/radrealms.so || die "radrealms.so not build"
+
+ #Copy radiusclient configuration files (#92878)
+ insinto /etc/ppp/radius
+ insopts -m0644
+ doins pppd/plugins/radius/etc/{dictionary*,issue,port-id-map,radiusclient.conf,realms,servers}
+
+ doman pppd/plugins/radius/pppd-radius.8
+ doman pppd/plugins/radius/pppd-radattr.8
+ fi
+
+ insinto /etc/modprobe.d
+ insopts -m0644
+ newins "${FILESDIR}/modules.ppp" ppp.conf
+
+ dodoc PLUGINS README* SETUP Changes-2.3 FAQ
+ dodoc "${FILESDIR}/README.mpls"
+
+ dosbin scripts/pon && \
+ dosbin scripts/poff && \
+ dosbin scripts/plog && \
+ doman scripts/pon.1 || die "failed to install pon&poff scripts"
+
+ # Adding misc. specialized scripts to doc dir
+ insinto /usr/share/doc/${PF}/scripts/chatchat
+ doins scripts/chatchat/* || die "failed to install chat scripts in doc dir"
+ insinto /usr/share/doc/${PF}/scripts
+ doins scripts/* || die "failed to install scripts in doc dir"
+
+ if use gtk; then
+ dosbin contrib/pppgetpass/{pppgetpass.vt,pppgetpass.gtk}
+ newsbin contrib/pppgetpass/pppgetpass.sh pppgetpass
+ else
+ newsbin contrib/pppgetpass/pppgetpass.vt pppgetpass
+ fi
+ doman contrib/pppgetpass/pppgetpass.8
+}
+
+pkg_postinst() {
+ if linux-info_get_any_version && linux_config_src_exists; then
+ echo
+ ewarn "If the following test report contains a missing kernel configuration option that you need,"
+ ewarn "you should reconfigure and rebuild your kernel before running pppd."
+ CONFIG_CHECK="~PPP ~PPP_ASYNC ~PPP_SYNC_TTY"
+ local ERROR_PPP="CONFIG_PPP:\t missing PPP support (REQUIRED)"
+ local ERROR_PPP_ASYNC="CONFIG_PPP_ASYNC:\t missing asynchronous serial line discipline (optional, but highly recommended)"
+ local WARNING_PPP_SYNC_TTY="CONFIG_PPP_SYNC_TTY:\t missing synchronous serial line discipline (optional; used by 'sync' pppd option)"
+ if use activefilter ; then
+ CONFIG_CHECK="${CONFIG_CHECK} ~PPP_FILTER"
+ local ERROR_PPP_FILTER="CONFIG_PPP_FILTER:\t missing PPP filtering support (REQUIRED)"
+ fi
+ CONFIG_CHECK="${CONFIG_CHECK} ~PPP_DEFLATE ~PPP_BSDCOMP ~PPP_MPPE"
+ local ERROR_PPP_DEFLATE="CONFIG_PPP_DEFLATE:\t missing Deflate compression (optional, but highly recommended)"
+ local ERROR_PPP_BSDCOMP="CONFIG_PPP_BSDCOMP:\t missing BSD-Compress compression (optional, but highly recommended)"
+ local WARNING_PPP_MPPE="CONFIG_PPP_MPPE:\t missing MPPE encryption (optional, mostly used by PPTP links)"
+ CONFIG_CHECK="${CONFIG_CHECK} ~PPPOE ~PACKET"
+ local WARNING_PPPOE="CONFIG_PPPOE:\t missing PPPoE support (optional, needed by rp-pppoe plugin)"
+ local WARNING_PACKET="CONFIG_PACKET:\t missing AF_PACKET support (optional, used by rp-pppoe and dhcpc plugins)"
+ if use atm ; then
+ CONFIG_CHECK="${CONFIG_CHECK} ~PPPOATM"
+ local WARNING_PPPOATM="CONFIG_PPPOATM:\t missing PPPoA support (optional, needed by pppoatm plugin)"
+ fi
+ check_extra_config
+ fi
+
+ if [ ! -e "${ROOT}/dev/.devfsd" ] && [ ! -e "${ROOT}/dev/.udev" ] && [ ! -e "${ROOT}/dev/ppp" ]; then
+ mknod "${ROOT}/dev/ppp" c 108 0
+ fi
+ if [ "$ROOT" = "/" ]; then
+ if [ -x /sbin/update-modules ]; then
+ /sbin/update-modules
+ else
+ /sbin/modules-update
+ fi
+ fi
+
+ # create *-secrets files if not exists
+ [ -f "${ROOT}/etc/ppp/pap-secrets" ] || \
+ cp -pP "${ROOT}/etc/ppp/pap-secrets.example" "${ROOT}/etc/ppp/pap-secrets"
+ [ -f "${ROOT}/etc/ppp/chap-secrets" ] || \
+ cp -pP "${ROOT}/etc/ppp/chap-secrets.example" "${ROOT}/etc/ppp/chap-secrets"
+
+ # lib name has changed
+ sed -i -e "s:^pppoe.so:rp-pppoe.so:" "${ROOT}/etc/ppp/options"
+
+ if use radius && [[ $previous_less_than_2_4_3_r5 = 0 ]] ; then
+ echo
+ ewarn "As of ${PN}-2.4.3-r5, the RADIUS configuration files have moved from"
+ ewarn " /etc/radiusclient to /etc/ppp/radius."
+ einfo "For your convenience, radiusclient directory was copied to the new location."
+ fi
+
+ echo
+ elog "Pon, poff and plog scripts have been supplied for experienced users."
+ elog "Users needing particular scripts (ssh,rsh,etc.) should check out the"
+ elog "/usr/share/doc/${PF}/scripts directory."
+
+ # move the old user-defined files into ip-{up,down}.d directories
+ # TO BE REMOVED AFTER SEPT 2008
+ local i
+ for i in ip-up ip-down; do
+ if [ -f "${ROOT}"/etc/ppp/${i}.local ]; then
+ mv /etc/ppp/${i}.local /etc/ppp/${i}.d/90-local.sh && \
+ ewarn "/etc/ppp/${i}.local has been moved to /etc/ppp/${i}.d/90-local.sh"
+ fi
+ done
+}